static void sRECONSTITUTE(int idx, char *out) { // Need 'max len' parameter for 'out' as well.  TO DO.
  int i;
  //char *saved1 = out;
  //char *saved2;
  out += strlen(out); // APPEND!
  //saved2 = out;
  makespace(c, idx+1); // probably not needed. We should only makespace for c when adding to it.
  for (i = c(idx).start_sp; i < c(idx).end_tok; i++) *out++ = source_address(i);
  *out = '\0';
  //fprintf(stderr, "Added: '%s'  Accumulated: '%s'\n", saved2, saved1);
}

//static char *sRECONSTITUTEs(int idx) {
//  static char out[1024]; out[1023] = '\0'; // cheap & nasty hack, for emergencies. Temporary.
//  sRECONSTITUTE(idx, out);
//  if (out[1023] != '\0') {
//    out[1023] = '\0';
//    fprintf(stderr, "*** Buffer overflow: \"%s\"\n", out);
//    exit(1);
//  }
//  return out;
//}

void compile_to_str(int astp, char *PARAM) {
  int i;

  if (astp < 0) {
    return; // For AST_*, '-phrase' denotes an optional item that
            // we don't want to print, when reconstituting the source.
            // For C_*, '-1' denotes a null choice.
  }

  int astop    = AstOP(astp);
  int alt      = Alt0(astp);
  int count    = AltCount(astp);
  int *A_child = &leftchild(astp); // Used with 'A_literal_offset' to index into a child of the AREC, *not* a child of the AST.

//\\ C<immediate> = {
//\\ #define INCLUDE_AST_DEBUG "show_ast.c"
//\\ int kw(int AST_op, int idx, int ap)
//\\ {
//\\   int data[4];
//\\ 
//\\   int i;
//\\ 
//\\   char *k = keyword(idx);
//\\ 
//\\   data[1] =  idx;
//\\ 
//\\   data[2] = A[ap+3]; // index of c[] array element
//\\   data[3] = strlen(k);
//\\ 
//\\   return mktuple(AST_op, 1, 3, data);
//\\ 
//\\ }
//\\ // variables used in line_reconstruction() moved here so they are available to semantic code in grammar.
//\\ #define STROPPED_KEYWORDS 1  /* alters behaviour of parse() */
//\\ int at_startofstatement = TRUE;
//\\ 
//\\ int saved = TRUE;
//\\ 
//\\ int at_startofline = TRUE;
//\\ 
//\\ int in_keyword = FALSE;
//\\ 
//\\ int in_alphanumeric = FALSE;
//\\ 
//\\ };

  switch (astop) {
    //\\ #  This is an extended grammar which now accepts constructs from multiple versions of Imp
    //\\ #  - it was primarily based on a correct Imp80 grammar, then modified to add Imp77 constructs
    //\\ #  followed by features from Pdp15 Imp, old Emas "Imp9", and Hamish's 68000 extensions, etc
    //\\ #  The original base grammar was:
    //\\ #    https://history.dcs.ed.ac.uk/archive/os/emas/emas2/compilers/imp80/imp80ps04.txt
    //\\ # 
    //\\ #  Since this accepts multiple dialects, I'm tempted to call it "PImp", short for "Polyglot Imp"...
    //\\ # 
    //\\ #  There is good info re the phrase structure grammar to be found at
    //\\ #  http://www.ancientgeek.org.uk/EMAS/EMAS_Manuals/IMP/A_Syntactic_and_Semantic_Definition_of_the_IMP_Language.pdf
    //\\ # 
    //\\ #  Built-in Phrases used by the line reconstruction phase:
    //\\ # 
    //\\ #  stropped letter (%a %b etc)
    case AST_stropped: //\\ B<stropped> = 0;
      sRECONSTITUTE(A[A_child[1]+A_literal_offset], PARAM);
      break;

    //\\ # 
    //\\ #  single-quoted string
    case AST_sqstring: //\\ B<sqstring> = 1;
      sRECONSTITUTE(A[A_child[1]+A_literal_offset], PARAM);
      break;

    //\\ # 
    //\\ #  double-quoted string
    case AST_dqstring: //\\ B<dqstring> = 2;
      sRECONSTITUTE(A[A_child[1]+A_literal_offset], PARAM);
      break;

    //\\ # 
    case AST_NL: //\\ B<NL> = 3;
      sRECONSTITUTE(A[A_child[1]+A_literal_offset], PARAM);
      break;

    //\\ # 
    case AST_char: //\\ B<char> = 4;
      sRECONSTITUTE(A[A_child[1]+A_literal_offset], PARAM);
      break;

    //\\ # 
    //\\ #  All parsers need an <EOF> phrase.
    //\\ # 
    case AST_EOF: //\\ B<EOF> = 5;
      sRECONSTITUTE(A[A_child[1]+A_literal_offset], PARAM);
      break;

    case AST__LIT:
      sRECONSTITUTE(A[A_child[1]+A_literal_offset], PARAM);
      break;


    case AST__KW:
      for (i = A_child[1]; i < A_child[1]+A_child[2]; i++) {
        // fprintf(stdout, "%s", String(i));
        sRECONSTITUTE(i, PARAM);
      }
      break;

    default:
      // relies on all objects in AST being pointers to other AST objects or one of the above terminals.
      for (i = 1; i <= count; i++) compile_to_str(child(astp,i), PARAM);
      break;
  }
}

void getstr(int astp, char *PARAM) { // Need to add an extra parameter for max string capacity
  PARAM[0] = '\0';
  compile_to_str(astp, PARAM);
}
