//#ifdef COMPILE_H
//#include COMPILE_H
//#endif

//#ifndef INCLUDE_AST_DEBUG
//#define INCLUDE_AST_DEBUG "show_ast.c"
//#endif

#ifndef SHOW_AST_INCLUDED
#define SHOW_AST_INCLUDED 1

void print_astop_name(int astp) {
  int i, spare, astop, alt, count, data0, data1, optional, negated;

  if (astp < 0) {
    return; // -phrase denotes an optional item we don't want to print when reconstituting the source
            // Not an idea mechanism. May change it later to add optional bits to 'op' field.
  }
  spare = AST(astp);
  astop = AST(astp+1)&DROP_SPECIAL_BITS;
  optional = AST(astp+1)&OPTIONAL_PHRASE;
  negated = AST(astp+1)&NEGATED_PHRASE;
  alt = AST(astp+2);
  count = AST(astp+3);
  data0 = AST(astp+4);
  data1 = AST(astp+5);
  
  if (astop < MAX_BIP) {
    switch (astop) {
    default:
      fprintf(stderr, "<%s%s=", optional?"?":negated?"!":"", astop>PHRASES_START?phrasename(astop-PHRASES_START):phrasename(astop));
      fprintf(stderr, "%d@%d> ", astop, astp);
    }
  } else {
    int *A_child = &AST[astp+AST_child1_offset]; // An index into a child of the AREC, *not* a child of the AST.
    if (astop == AST__LIT) {
      fprintf(stderr, " <Literal='");
      RECONSTITUTE(A[A_child[1]+A_literal_offset], stderr);
      fprintf(stderr, "'@%d> ", astp);
    } else if (astop == AST__KW) {
      fprintf(stderr, " <Keyword=");
      for (i = A_child[1]; i < A_child[1]+A_child[2]; i++) {
        RECONSTITUTE(i, stderr);
      }
      fprintf(stderr, "@%d> ", astp);
    } else if (astop-PHRASES_START > MAX_PHRASE) {
      fprintf(stderr, " <PHRASE %d@%d> ", astop-PHRASES_START, astp); // I don't think it shouldever get here ...
    } else if (astop > MAX_PHRASE) {
      fprintf(stderr, " <Phrase %d@%d> ", astop, astp);               // or here ...
    } else {
      fprintf(stderr, " <%s%s@%d> ", optional?"?":negated?"!":"", astop>PHRASES_START?phrasename(astop-PHRASES_START):phrasename(astop), astp);
    }
  }
}

void print_ast(int astp, int depth) {
  // Although currently the AST looks a lot like the AREC, this will not always be
  // the case, as the AST is simplified...
  int i, astop, alt, count, subphrase;
  // p is the return from mktuple() for proper phrases.

  if (astp < 0) {
    return; // -phrase denotes an optional item we don't want to print when reconstituting the source
            // Not an idea mechanism. May change it later to add optional bits to 'op' field.
  }

  astop  = AST(astp+1);
  if (astop < MAX_BIP) {
    print_astop_name(astp);
    fprintf(stderr, "\n");
    return;
  }
  alt = AST(astp+2);
  count = AST(astp+3);
  indent(depth, stderr);
  print_astop_name(astp);
  fprintf(stderr, " ::= ");
  for (i = astp+4; i < astp+4+count; i++) {
    if (i >= astp+4) print_astop_name(AST(i));
  }
  fprintf(stderr, ";\n");
  for (i = astp+4; i < astp+4+count; i++) {
    if ((AST(i)>=0) && (AST(AST(i)+1)>=MAX_BIP)) {
      if ((AST(AST(i)+1) != AST__KW) && (AST(AST(i)+1) != AST__LIT)) print_ast(AST(i), depth+1);  // MAX_BIP? Not PHRASES_START+MAX_BIP?  CHECK!!!
    }
  }
}
#endif
